(provide 'theenv)
; THE global first-class environment
; can be modified locally w/ fluid-let.
(define THE-ENV (env:new))
(define-macro% ($ sym . args)
  "find a object named in THE-ENV"
  (let ((tmp `(env:get THE-ENV ',sym)))
    ;((tmp `(env:try-get THE-ENV ',sym (lambda (b) b) (lambda () ,sym))))
    (if (null? args) tmp (cons tmp args))))
(define-macro% ($define sym . def)
  "add a definition to THE-ENV"
  (cond
   ((symbol? sym)
     `(env:add-definition! THE-ENV ',sym ,@def))
   ((pair? sym)
     `(env:add-definition! THE-ENV ',(car sym) (lambda ,(cdr sym) ,@def)))))
